/***
 * 
 * Felipe Brahm
 * Ayudante de Ctedra
 * Introduccin a la Programacin - IIC1102 Seccin 4
 * Pontificia Universidad Catlica de Chile
 *
 * lebrahm <at> uc <punto> cl
 * ICQ#50566818
 *
 * (CC)2006
 * 
 * */

/*
 * 
 * NOTA:
 * La solucin de este problema no es ejecutable, ya que hara falta una
 * clase "Principal" que creara una instancia de este objeto para luego
 * utilizarlo.
 * 
 * De todos modos, pueden leer el cdigo para estudiarlo y entenderlo.
 * 
 * */

public class Pelicula {

	private Imagen[] peli;
	
	public Pelicula(Imagen[] peli) {
		
		this.peli = peli;

	}
	
	public Imagen getCuadro(int num) {
		
		if(num < peli.length)
			return peli[num];
		
		return null;
		
	}
	
	public boolean sonIguales(int numCuadro, int i, int j, Imagen img) {

		if(numCuadro >= peli.length)
			return false;

		int[][] i1;
		int[][] i2;
		
		i1 = peli[numCuadro].getArreglo();
		i2 = img.getArreglo();

		for(int x = 0; x < i2.length; ++x) {
			
			if(i+x >= i1.length)
				return false;
			
			for(int y = 0; y < i2[x].length; ++y) {
				
				if(j+y >= i1[x].length)
					return false;
				
				if(i1[i+x][j+y] != i2[x][y])
					return false;
				
			}			
			
		}

		//si lleg hasta aqu, entonces son iguals
		return true;

	}
	
	public int buscarImagen(Imagen img) {
		
		//recorro todos los cuadros de la pelcula
		for(int c = 0; c < peli.length; ++c) {
			
			int[][] i1 = peli[c].getArreglo();
			
			for(int i = 0; i < i1.length; ++i) {
				
				for(int j = 0; j < i1[i].length; ++j) {
					
					if(sonIguales(c, i, j, img))
						return c;
					
				}
				
			}
			
		}
		
		//si lleg hasta ac, entonces no lo encontr y retorna -1
		return -1;
		
	}
	
}